unit vcl_tools;

interface
uses Forms,Windows,ExtCtrls,ComCtrls;

type TXCallBack=procedure;
procedure CreateXPanel(Form:TForm;Width,Height:Integer);
procedure CreateXPanelCallback(Form:TForm;Width,Height:Integer;Callback:TXCallback);
procedure ReleaseXPanel;
procedure ReleaseXPanelCallback(Callback:TXCallback);
procedure XProgress(const Min,Max,Pos:Integer);
procedure GetDimensions(AOrigin,ADestPt:TPoint;var rWidth,rHeight:Integer;var rRect:TRect);

procedure CenterForm(Form, ParentForm:TForm);

var XPanel:TPanel;
    XProgressBar:TProgressBar;
    XProcessing:Boolean;
    XInstance:Integer;
const defXWidth = 250;
const defXHeight = 50;


implementation

procedure CreateXPanel(Form:TForm;Width,Height:Integer);
begin
   Inc(XInstance);
   XProcessing:=True;
   XPanel:=TPanel.Create(Form);
   XPanel.Parent:=Form;
   XPanel.Width:=Width;
   XPanel.Height:=Height;
   XPanel.Left:=(Form.ClientWidth - XPanel.Width) div 2;
   XPanel.Top:=(Form.ClientHeight - XPanel.Height) div 2;
   XPanel.Visible:=True;
   XProgressBar:=TProgressBar.Create(XPanel);
   XprogressBar.Parent:=XPanel;
   XProgressBar.Width:=Width-10;
   XProgressBar.Height:=10;
   XProgressBar.Top:=Xpanel.Height-14;
   XProgressBar.Left:=(Xpanel.Width-XProgressBar.Width) div 2;
end;

procedure CreateXPanelCallback(Form:TForm;Width,Height:Integer;Callback:TXCallback);
begin
  CreateXPanel(Form,Width,Height);
  if Assigned (Callback) then Callback;
end;

procedure ReleaseXPanel;
begin
   Dec(XInstance);
   if XInstance<=0 then
   begin
     XProcessing:=False;
     XProgressBar.Free;
     XPanel.Free;
   end;
end;

procedure ReleaseXPanelCallback(Callback:TXCallback);
begin
   ReleaseXPanel;
   if Assigned (Callback) then Callback;
end;

procedure CenterForm(Form, ParentForm:TForm);
begin
 if Form.Width < ParentForm.Width then
  Form.Left:=ParentForm.Left+((ParentForm.Width - Form.Width) div 2)
 else Form.Left:=ParentForm.Left;
 if Form.height < ParentForm.Height then
  Form.Top:=ParentForm.Top+((ParentForm.Height - Form.Height) div 2)
 else Form.Top:=ParentForm.Top;
end;

procedure XProgress(const Min,Max,Pos:Integer);
begin
  Application.ProcessMessages;
  XProgressBar.Min:=Min;
  XProgressBar.Max:=Max;
  XProgressBar.Position:=Pos;
end;

procedure GetDimensions(AOrigin,ADestPt:TPoint;var rWidth,rHeight:Integer;var rRect:TRect);
begin
  if AOrigin.X> ADestPt.X then begin
     rRect.Right:=AOrigin.X;
     rRect.Left:=ADestPt.X;
  end else
  begin
     rRect.Left:=AOrigin.X;
     rRect.Right:=ADestPt.X;
  end;

  if AOrigin.Y> ADestPt.Y then begin
     rRect.Bottom:=AOrigin.Y;
     rRect.Top:=ADestPt.Y;
  end else
  begin
     rRect.Top:=AOrigin.Y;
     rRect.Bottom:=ADestPt.Y;
  end;
  rWidth:=rRect.Right-rRect.Left;
  rHeight:=rRect.Bottom-rRect.Top;
end;

initialization
  XProcessing:=False;
  XInstance:=0;

end.
